import org.codehaus.groovy.grails.commons.GrailsApplication
            
class BookController {
    def scaffold = true

    def update = {
        def book = Book.get( params.id )
        if(book) {
            book.properties = params
            if(!book.hasErrors() && book.save()) {
                flash.message = "Book ${params.id} updated"
                upload(request, book)
                redirect(action:show,id:book.id)
            }
            else {
                render(view:'edit',model:[book:book])
            }
        }
        else {
            flash.message = "Book not found with id ${params.id}"
            redirect(action:edit,id:params.id)
        }
    }

    def save = {
	    def book = new Book(params)
        if(!book.hasErrors() && book.save()) {
            flash.message = "Book ${book.id} created"
            upload(request, book)
            redirect(action:show,id:book.id)
        }
        else {
            render(view:'create',model:[book:book])
        }
    }
    
    def upload = { request, book ->
	    def file = request.getFile('imageFile')
	    if(!file.empty) {
	    	def path = "/images/jackets/${book.id}"
            file.transferTo(new File(servletContext.getRealPath(path)))
            // 1.0.3で取得内容が変更されたため修正
            // book.imageUrl = servletContext.servletContextName + path
            book.imageUrl = servletContext.contextPath + path
            book.save()
	    }
    }
    
}