/**
 * アカウントのドメインクラス.
 */
class Account implements Serializable {

    /**
     * 客.
     */
    Customer customer
    
    /**
     * 注文、役割.
     */
    static hasMany = [orders : Order, roles : Role]
    
    static belongsTo = Role

    static fetchMode = [orders : "eager"]
    
    /**
     * アカウント名.
     */
    String name

    /**
     * パスワード.
     */
    String password

    /**
     * 有効かどうか.
     */
    boolean enabled = true

    transient onLoad = {
        discard()
    }
    
    static constraints = {
    	customer(nullable:true)
    	name(unique:true)
    	password(blank:false)
    	enabled()
    }
}
