<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
  <head>
    <meta name="layout" content="orderMain"/>
    <title>精算確認</title>
  </head>
  <body>
    <div class="body">
      <h1>精算確認</h1>
      <g:if test="${order}">
        <div class="list">
          <table>
            <thead>
              <tr>
                <th>No.</th>
                <th>タイトル</th>
                <th>価格</th>
                <th>冊数</th>
                <th>小計</th>
              </tr>
            <thead>
            <tbody>
              <g:each status="i" var="orderDetail" in="${order.orderDetails}">
                <tr class="${(i % 2) == 0 ? 'odd' : 'even'}">
                  <td><span id="no$${orderDetail.book.id}">${i + 1}</span></td>
                  <td><span id="title$${orderDetail.book.id}">${orderDetail?.book.title?.encodeAsHTML()}</span></td>
                  <td><span id="price$${orderDetail.book.id}">${orderDetail?.book.price}</span></td>
                  <td><span id="quantity$${orderDetail.book.id}">${orderDetail.quantity}</span></td>
                  <td><span id="subTotal$${orderDetail.book.id}">${orderDetail?.book.price * orderDetail?.quantity}</span>円</td>
                </tr>
              </g:each>
              <tr style="border-top:double #ccc;">
                <td></td>
                <td></td>
                <td></td>
                <td align="right"><b>合計</b></td>
                <td><span id="totalPrice">${totalPrice}</span>円</td>
              </tr>
            </tbody>
          </table>
        </div>
      </g:if>

      <g:if test="${order.customer}">
        <div class="dialog">
          <table>
            <tbody>
              <tr class="prop">
                <td valign="top" class="name">名前:</td>
                <td valign="top" class="value"><span id="name">${order.customer.name}</span></td>
              </tr>
              <tr class="prop">
                <td valign="top" class="name">住所:</td>
                <td valign="top" class="value"><span id="address">${order.customer.address}</span></td>
              </tr>
              <tr class="prop">
                <td valign="top" class="name">電話番号:</td>
                <td valign="top" class="value"><span id="phoneNumber">${order.customer.phoneNumber}</span></td>
              </tr>
              <tr class="prop">
                <td valign="top" class="name">メールアドレス:</td>
                <td valign="top" class="value"><span id="email">${order.customer.email}</span></td>
              </tr>
              <tr class="prop">
                <td valign="top" class="name">支払い方法:</td>
                <td valign="top" class="value"><span id="paymentMethod">${order.customer.paymentMethod}</span></td>
              </tr>
            </tbody>
          </table>
        </div>
      </g:if>

      <div class="buttons">
        <g:form action="credit">
          <g:submitButton name="next" value="精算"/>
          <g:submitButton name="back" value="戻る"/>
        </g:form>
      </div>

      <g:hasErrors bean="${order}">
        <div class="errors">
          <g:renderErrors bean="${order}"/>
        </div>
      </g:hasErrors>
      <g:hasErrors bean="${order.customer}">
        <div class="errors">
          <g:renderErrors bean="${order.customer}"/>
        </div>
      </g:hasErrors>
    </div>
  </body>
</html>
